#include <iostream>
#include <vector>

using namespace std;

void primes_up_to( unsigned long n)
{
  unsigned long m = (n+1)/2 - 1;
  vector<bool>  bits(m, true);

  cout << "2";

  unsigned long j = 0;  // j = index von p
  unsigned long p = 3;  // p = 2j + 3;
  unsigned long q = 3;  // q = 2j^2 + 6j + 3, index von p^2

  while ( q < m )   // p^2 > n ?
  {
    if ( bits[j] )  // p = 2j + 3 prim ?
    {
      cout << " - " << p;
      unsigned long k;    // k = index von p^2
      for ( k = q; k < m; k += p )
        bits[k] = false;
    }
    j++;           
    p += 2;       
    q += 2*p - 2;
  }

  while ( j < m )   // p <= n ?
  {
    if ( bits[j] )  // p = 2j + 3 prim ?  
    {
      cout << " - " << p;
    }
    j++;
    p +=2;
  }
}

int
main()
{
  int N;
  cout << "Primzahlen bis ";
  cin  >> N;

  primes_up_to( N);
  cout << endl;

  return 0;
}
