#ifndef STACK_T_H
#define STACK_T_H

template < typename T>       // template <class T>
class stack
// stack of elements of type T 
{
  public:
    stack();
    stack(const stack<T>&);
    ~stack();

    stack<T>& operator=(const stack<T>&);   // Zuweisung

    void   push(const T&);
    void   pop();
    T      top() const;
    bool   empty() const;

  private: 
    int  sz;
    int  tp;
    T*   A;
};

#include "stack_t.C"

#endif // STACK_T_H
